package com.diaoyun.zion.chinafrica.dao;

import com.diaoyun.zion.chinafrica.entity.TbCfCouponEntity;
import com.diaoyun.zion.master.dao.BaseDao;

import java.util.Date;
import java.util.List;

/**
 * 优惠券表Dao
 *
 * @author G
 * @date 2019-08-14 09:11:48
 */
public interface TbCfCouponDao extends BaseDao<TbCfCouponEntity> {

    /**
     * 获取用户所有可以使用的优惠券
     * @param userId
     * @param nowTime
     * @return
     */
    List<TbCfCouponEntity> queryUserAvailableCoupon(String userId, Date nowTime);

    /**
     * 更改优惠券统计 暂不用
     * @param couponId
     * @return
     */
    int updateUsedCount(String couponId);

    /**
     * 获取已使用的优惠券
     * @param userId
     * @return
     */
    List<TbCfCouponEntity> queryUserUsedCoupon(String userId);

    /**
     * 获取已过期的优惠券
     * @param userId
     * @return
     */
    List<TbCfCouponEntity> queryUserExpiredoupon(String userId, Date nowTime);

    /**
     * 根据优惠券种类获取优惠券
     * @param couponCategory
     * @return
     */
    List<TbCfCouponEntity> getCouponByCategory(Integer couponCategory,Date nowTime);

    /**
     *如果vaild 是1的话就是注册就送该优惠券，可以是送一张也可以送多张
     */
    List<TbCfCouponEntity> getCouponAndVaildAll();

    int updates(TbCfCouponEntity tbCfCoupon);
}
